## JIT

### a Just-in-Time C/Rust compiler embedded in an LV2 plugin

#### Build status

[![build status](https://gitlab.com/OpenMusicKontrollers/jit.lv2/badges/master/build.svg)](https://gitlab.com/OpenMusicKontrollers/jit.lv2/commits/master)

### Binaries

For GNU/Linux (64-bit, 32-bit, armv7), Windows (64-bit, 32-bit) and MacOS
(64/32-bit univeral).

To install the plugin bundle on your system, simply copy the __jit.lv2__
folder out of the platform folder of the downloaded package into your
[LV2 path](http://lv2plug.in/pages/filesystem-hierarchy-standard.html).

<!--
#### Stable release

* [jit.lv2-0.16.0.zip](https://dl.open-music-kontrollers.ch/jit.lv2/stable/jit.lv2-0.16.0.zip) ([sig](https://dl.open-music-kontrollers.ch/jit.lv2/stable/jit.lv2-0.16.0.zip.sig))
-->

#### Unstable (nightly) release

* [jit.lv2-latest-unstable.zip](https://dl.open-music-kontrollers.ch/jit.lv2/unstable/jit.lv2-latest-unstable.zip) ([sig](https://dl.open-music-kontrollers.ch/jit.lv2/unstable/jit.lv2-latest-unstable.zip.sig))

### Sources

<!--
#### Stable release

* [jit.lv2-0.16.0.tar.xz](https://git.open-music-kontrollers.ch/lv2/jit.lv2/snapshot/jit.lv2-0.16.0.tar.xz)
-->

#### Git repository

* <https://git.open-music-kontrollers.ch/lv2/jit.lv2>

<!--
### Packages

* [ArchLinux](https://www.archlinux.org/packages/community/x86_64/jit.lv2/)
-->

### Bugs and feature requests

* [Gitlab](https://gitlab.com/OpenMusicKontrollers/jit.lv2)
* [Github](https://github.com/OpenMusicKontrollers/jit.lv2)

### Plugins

#### Mono

Mono version of the plugin.

Prototype new audio filters in C/Rust directly in
your favorite running host, without the need to restart the latter after
code changes.

#### Stereo

Stereo version of the plugin.

Prototype new audio filters in C/Rust directly in
your favorite running host, without the need to restart the latter after
code changes.

### Dependencies

* [LV2](http://lv2plug.in) (LV2 Plugin Standard)

You'll need to have a C and/or Rust compiler installed at runtime for this
plugin to work

* [GCC](https://gcc.gnu.org) (GNU Compiler Collection)
* [CLANG](https://clang.llvm.org) (Clang C Language Family Frontend for LLVM)
* [RUST](https://rust-lang.org) (Rust)

### Build / install

	git clone https://git.open-music-kontrollers.ch/lv2/jit.lv2
	cd jit.lv2
	meson build
	cd build
	ninja -j4
	sudo ninja install

### GUI

This plugin features an external LV2 plugin GUI, which does nothing else than
just opening the plugin's C/Rust source in your favorite editor and monitor its
modification state.

Currently, the editor has to be defined via an environment variable. You can
use either the environment varialbe *EDITOR* or *JIT_EDITOR*, whereby the
latter will take precedence over the former.

    export EDITOR='urxvt -e nvim -o2'

If no environment variable is defined, the default fallback invocation commands
are defined as follows:

* 'xterm -e vim -o2' (Unix)
* 'open -nW' (MacOS)
* 'cmd /c start /wait' (Windows)

Whenever you save the C/Rust source, the plugin will try to just-in-time compile and
inject it. Potential warnings and errors are reported in the plugin host's log
and in a log file opened in parallel to the source file.

### License

Copyright (c) 2019 Hanspeter Portner (dev@open-music-kontrollers.ch)

This is free software: you can redistribute it and/or modify
it under the terms of the Artistic License 2.0 as published by
The Perl Foundation.

This source is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
Artistic License 2.0 for more details.

You should have received a copy of the Artistic License 2.0
along the source as a COPYING file. If not, obtain it from
<http://www.perlfoundation.org/artistic_license_2_0>.
